program Soutez;
{$APPTYPE CONSOLE}
{ RTTI EXPLICIT METHODS([]) PROPERTIES([]) FIELDS([])}
{$STRINGCHECKS OFF}
{$INLINE ON}
{$O+}
{$R-}
uses
  Sysutils,
  windows,
  classes;

const
  ciCount = 20;
  asData : array [1..ciCount] of string =
  ('<body>', '<head>', '<html>', '<p>', '<table>', '<li>', '<ul>', '<div>', '<img>',   //9
   '<td>','<tr>', '<h1>', '<h2>', '<h3>', '<h4>', '<a>', '<em>', '<strong>', // 18
   '<code>', '<pre>');    //20

var
  aiCount: array [1..ciCount] of integer;

const
  LOOP_COUNT = 40;
var
  pData: PByteArray;
  f: TFileStream;
  tick, tickend, frequency: Int64;

  sOut:string;
  x: Integer;
  Loops: integer;
  CurTime, TotalTime, MaxTime, MinTime: DWORD;

// moje lokalni promenne
  I: Integer;
  Hash: Integer;
//  HashMap: array[0..255] of Integer; // pro kontrolu unikatnosti hashu
  CountTab: array[0..255] of Integer;
  P: PChar;
  PD: PAnsiChar;
begin
  f:= TFileStream.Create('data.bin', fmOpenRead );
  try
    GetMem(pData, f.Size);
    f.Read(pData^, f.Size);
    TotalTime := 0;
    MaxTime := 0;
    MinTime := $ffffffff;

    for Loops := 1 to LOOP_COUNT do
    begin
      QueryPerformanceFrequency(frequency);

      QueryPerformanceCounter(tick);
// zacatek souteze, predavani je zalezitosti programatora
   // v pData jsou data
   // zde si muzete hrat

      FillChar(CountTab, SizeOf(CountTab), 0);
      // FillChar(HashMap, SizeOf(HashMap), 0);

      Hash := 0;
      PD := PAnsiChar(pData);
      for I := 1 to f.Size - 1 do
      begin
        if PD^ = #$0D then
        begin
          Inc(CountTab[Byte(Hash)]);
          Hash := not (49 - $0A) + 1;
        end else
          Hash := Hash xor (Ord(PD^) - 49);  // Ord('/') == 47

        Inc(PD);
      end;

      for I := 1 to ciCount do
      begin
        Hash := 0;
        P := PChar(asData[I]);
        while P <> '' do
        begin
          Hash := Hash xor (Ord(P^) - 49);
          Inc(P);
        end;
        // Assert(HashMap[Hash] = 0, 'Duplicitni hash');
        // HashMap[Hash] := I;
        aiCount[I] := CountTab[Hash];
      end;

      QueryPerformanceCounter(tickend);
// konec souteze
      CurTime := Round(1000*(tickend - tick)/frequency);
      Inc(TotalTime, CurTime);
      if CurTime < MinTime then
        MinTime := CurTime;
      if CurTime > MaxTime then
        MaxTime := CurTime;
    end;
    writeln(format('Autor: Tom Konek,  kompilator:%f', [CompilerVersion]));

    writeln(Format('Last time = [%d]', [CurTime]));
    writeln(Format('Min time = [%d], Average time = [%d], Max time = [%d]',
      [MinTime, TotalTime div LOOP_COUNT, MaxTime]));
    for x := 1 to 20 do
      Writeln(Format('%s = %d', [asData[x], aiCount[x]]));

    FreeMem(pData);
  finally
    FreeAndNil(f);
  end;
end.
